cmake_minimum_required(VERSION 2.8.3)
project(kdl_trajectories)

set(CMAKE_BUILD_TYPE Release)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_compile_options(
-Wunused-function  
-Wunused-label     
-Wunused-value     
-Wunused-variable  
)

find_package(catkin REQUIRED
            roscpp
            message_generation
            geometry_msgs
            nav_msgs
            kdl_conversions
            kdl_msgs
            )
            
find_package(Eigen3 REQUIRED)
find_package(orocos_kdl REQUIRED)


add_message_files(
  FILES
  TrajProperties.msg
  Trajectory.msg
  PublishTraj.msg
)

add_service_files(
  FILES
  UpdateWaypoints.srv
)

generate_messages(
  DEPENDENCIES
  kdl_msgs
  geometry_msgs
  nav_msgs
) 

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
INCLUDE_DIRS include
LIBRARIES kdl_trajectories
CATKIN_DEPENDS roscpp
geometry_msgs
nav_msgs
DEPENDS  
orocos_kdl
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
)

## Declare a C++ library
add_library(${PROJECT_NAME}
  src/kdl_trajectories.cpp
)

target_include_directories(${PROJECT_NAME} PUBLIC
  include/
  ${EIGEN3_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${orocos_kdl_LIBRARIES}
)

# ## Declare a C++ executable
# ## With catkin_make all packages are built within a single CMake context
# ## The recommended prefix ensures that target names across packages don't collide
# add_executable(${PROJECT_NAME}_node src/test.cpp)

# ## Specify libraries to link a library or executable target against
#  target_link_libraries(${PROJECT_NAME}_node
#     ${PROJECT_NAME}
#  )

# target_include_directories(${PROJECT_NAME}_node SYSTEM PUBLIC
#   include
#   src
#   ${EIGEN3_INCLUDE_DIRS}
#   ${catkin_INCLUDE_DIRS}
# )
## Add cmake target dependencies of the library
## as an example, code may need to be generated before libraries
## either from message generation or dynamic reconfigure
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Rename C++ executable without prefix
## The above recommended prefix causes long target names, the following renames the
## target back to the shorter version for ease of user use
## e.g. "rosrun someones_pkg node" instead of "rosrun someones_pkg someones_pkg_node"
# set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")



## Add cmake target dependencies of the executable
## same as for the library above
# add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})



#############
## Install ##
#############

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

install(DIRECTORY trajectories
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
